﻿
namespace WpfAppCamboApp
{
    using System;
    using System.Collections.Generic;
    using System.Collections.ObjectModel;
    using System.IO;
    using Syncfusion.Windows.Controls.Gantt;

    class ViewModel
    {

        private List<string> list_firstCol, list_secondCol, listC, listD, listE, listF, listG, Custom;
        private List<int> ListtotalDays;

        /// <summary>
        /// Initializes a new instance of the <see cref="ViewModel"/> class.
        /// </summary>
        public ViewModel()
        {
            _taskDetails= this.GetTaskDetails();
            _customScheduleSource = this.GetCustomScheduleSource();
        }

        private ObservableCollection<Model> _taskDetails;

        /// <summary>
        /// Gets or sets the task collection.
        /// </summary>
        /// <value>The task collection.</value>
        public ObservableCollection<Model> TaskDetails
        {
            get 
            {
                 return _taskDetails; 
            }

            set 
            {
                _taskDetails = value;
            }
        }

        private IList<GanttScheduleRowInfo> _customScheduleSource;

        /// <summary>
        /// Gets or sets the custom schedule source.
        /// </summary>
        /// <value>The custom schedule source.</value>
        public IList<GanttScheduleRowInfo> CustomScheduleSource
        {
            get
            {
                return _customScheduleSource;
            }

            set
            {
                _customScheduleSource = value;
            }
        }

        /// <summary>
        /// Gets the custom schedule source.
        /// </summary>
        /// <returns></returns>
        public IList<GanttScheduleRowInfo> GetCustomScheduleSource()
        {
            return new List<GanttScheduleRowInfo>
                       {
                           new GanttScheduleRowInfo
                               {
                                   TimeUnit = TimeUnit.Days,
                                   PixelsPerUnit = 45,
                                   CellTextFormat = "MMM dd"
                               }
                       };
        }

        /// <summary>
        /// Gets the task details.
        /// </summary>
        /// <returns></returns>
        ObservableCollection<Model> GetTaskDetails()
        {
            ObservableCollection<Model> task = new ObservableCollection<Model>();


            modifyData();
            for (int i = 0; i < 30; i++)
            {

                task.Add(new Model { TaskId = 1, TaskName = "Scope", StartDate = DateTime.Parse(listC[i]), FinishDate = DateTime.Parse(listG[i]), Range = list_firstCol[i] + "-" + list_secondCol[i] });

                //task.Add(new Item() { Name = list_firstCol[i] + "-" + list_secondCol[i] });
                //Item Person = new Item() { Name = " " };
                //MainWindow mw = new MainWindow();

                //Person.InLineItems.Add(new Item() { StartDate = new DateTime(2012, 01, 07), FinishDate = new DateTime(2012, 01, 11), Name = "Market Analysis", Progress = 50d });

                //Person.InLineItems.Add(new Item() { StartDate = DateTime.Parse(listC[i]), FinishDate = DateTime.Parse(listG[i]), Name = list_firstCol[i] + list_secondCol[i] });

               // teams[i].SubItems.Add(Person);
            }



            //task.Add(new Model { TaskId = 1, TaskName = "Scope", StartDate = new DateTime(2011, 7, 3, 1, 0, 0), FinishDate = new DateTime(2011, 7, 14, 5, 0, 0) });
            //task[0].Child.Add(new Model { TaskId = 2, TaskName = "Determine project office scope", StartDate = new DateTime(2011, 7, 3), FinishDate = new DateTime(2011, 7, 5), Range = "10-3" });
            //task[0].Child.Add(new Model { TaskId = 3, TaskName = "Justify Project Offfice via business model", StartDate = new DateTime(2011, 7, 3), FinishDate = new DateTime(2011, 7, 7), Range = "10-4" });
            //task[0].Child.Add(new Model { TaskId = 4, TaskName = "Secure executive sponsorship", StartDate = new DateTime(2011, 7, 3), FinishDate = new DateTime(2011, 7, 14), Range = "11-3" });
            //task[0].Child.Add(new Model { TaskId = 5, TaskName = "Secure complete", StartDate = new DateTime(2011, 7, 14), FinishDate = new DateTime(2011, 7, 14), Range = "11-4" });
            
            
            // 2nd Task
            //task.Add(new Model { TaskId = 6, TaskName = "Risk Assessment", StartDate = new DateTime(2011, 7, 8), FinishDate = new DateTime(2011, 7, 24), Range = "11-5" });
            
            return task;
        }

        public void modifyData()
        {

            //using (var reader = new StreamReader(@"Unit Records Sample_modified.csv"))
            using (var reader = new StreamReader(@"Unit Records Sample_time.csv"))
            {
                list_firstCol = new List<string>();
                list_secondCol = new List<string>();
                listC = new List<string>();
                listD = new List<string>();
                listE = new List<string>();
                listF = new List<string>();
                listG = new List<string>();
                Custom = new List<string>();
                ListtotalDays = new List<int>();
                while (!reader.EndOfStream)
                {
                    var line = reader.ReadLine();
                    var values = line.Split(',');

                    list_firstCol.Add(values[0]);
                    list_secondCol.Add(values[1]);
                    listC.Add(values[2]);
                    listD.Add(values[3]);
                    listE.Add(values[4]);
                    listF.Add(values[5]);
                    listG.Add(values[6]);

                    //int totalList = Math.Abs(Convert.ToInt32((DateTime.Parse(values[6]) - DateTime.Parse(values[2])).TotalDays));
                    //Console.WriteLine(totalList);



                    //ListtotalDays.Add(totalList);

                }
            }
        }
    }


}
