﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Interactivity;
using Syncfusion.Windows.Controls.Gantt;
using System.Windows;

namespace WpfAppCamboApp
{
    using Syncfusion.Windows.Controls.Grid;

    public class InitialSetupBehavior:Behavior<GanttControl>
    {
        /// <summary>
        /// Called when [attached].
        /// </summary>
        protected override void OnAttached()
        {
            this.AssociatedObject.Loaded += new RoutedEventHandler(AssociatedObject_Loaded);
        }

        /// <summary>
        /// Handles the Loaded event of the AssociatedObject control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.RoutedEventArgs"/> instance containing the event data.</param>
        void AssociatedObject_Loaded(object sender, RoutedEventArgs e)
        {
            if (this.AssociatedObject.GanttGrid != null)
            {
                this.AssociatedObject.GanttGrid.UpdateMode = Syncfusion.Windows.Controls.Grid.UpdateMode.PropertyChanged;

                // Remove all the columns
                this.AssociatedObject.GanttGrid.Columns.Clear();

                GridTreeColumn column = new GridTreeColumn { MappingName = "Range", HeaderText = "Range", Width = 100 };

                // adding the custom columns to GanttGrid(Table)
                this.AssociatedObject.GanttGrid.Columns.Add(column);
            }
        }

        /// <summary>
        /// Called when [detaching].
        /// </summary>
        protected override void OnDetaching()
        {
            this.AssociatedObject.Loaded -= new RoutedEventHandler(AssociatedObject_Loaded);
        }
    }
}
