﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;


namespace WpfAppSample
{
    public class CsvParseData
    {
        public string INSTALLCODE { get; set; }
        public string SITE { get; set; }
        public string LOCATION { get; set; }
        public string INSTALLED { get; set; }
        public string UNINSTALLED { get; set; }
        public string NOTES { get; set; }


    }

    


    public static class CsvParseDataService
    {
        // Parsing data from CSV and manupulate into respective variable of the table grid
        public static List<CsvParseData> ReadFile(string filepath)
        {
            var lines = File.ReadAllLines(filepath);

            var data = from l in lines.Skip(1)
                       let split = l.Split(',')
                       select new CsvParseData
                       {
                         
                           INSTALLCODE = split[0]+"-"+split[1],
                           INSTALLED = split[2],
                           LOCATION = split[3],
                           SITE = split[4],
                           UNINSTALLED = split[6],
                           NOTES = split[7]
                       };
            return data.ToList();
        }
    }
}